; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Anaglyph maker script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/10/23
;     - Initial relase (script-fu-anaglyph-one-map)
; version 0.2  by Iccii 2001/10/27
;     - Added script-fu-anaglyph-two-layer function
;     - splited the common function (anaglyph-maker)
;
; --------------------------------------------------------------------
;     Reference Web site
; http://www.stereoeye.com/
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;

	;; ̃C[w肵^CṽAiOtɂ
	;;   - ̃C[WAẼC[W
(define (anaglyph-maker image layer1 layer2 type)
  (let* ((WHITE '(255 255 255)))
    (cond
	; Gray (Red-Cyan)
      ((= type 0)
        (gimp-levels layer1  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer1 GREEN-LUT 0 255 1.00 255 255)
        (gimp-levels layer2  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer2 GREEN-LUT 0 255 1.00 255 255)
        (gimp-hue-saturation layer2 ALL-HUES 180 0 0)
        (gimp-layer-set-opacity layer1 100)
        (gimp-layer-set-opacity layer2 100)
        (gimp-layer-set-mode layer1 NORMAL-MODE)
        (gimp-layer-set-mode layer2 MULTIPLY-MODE))
	; Red-Green
      ((= type 1)
        (gimp-levels layer1  BLUE-LUT 0 255 1.00   0   0)
        (gimp-levels layer1 GREEN-LUT 0 255 1.00 255 255)
        (gimp-levels layer2  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer2 GREEN-LUT 0 255 1.00 255 255)
        (gimp-hue-saturation layer2 ALL-HUES 180 0 0)
        (gimp-layer-set-opacity layer1 100)
        (gimp-layer-set-opacity layer2 100)
        (gimp-layer-set-mode layer1 NORMAL-MODE)
        (gimp-layer-set-mode layer2 MULTIPLY-MODE))
	; Red-Blue
      ((= type 2)
        (gimp-levels layer1  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer1 GREEN-LUT 0 255 1.00   0   0)
        (gimp-levels layer2  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer2 GREEN-LUT 0 255 1.00 255 255)
        (gimp-hue-saturation layer2 ALL-HUES 180 0 0)
        (gimp-layer-set-opacity layer1 100)
        (gimp-layer-set-opacity layer2 100)
        (gimp-layer-set-mode layer1 NORMAL-MODE)
        (gimp-layer-set-mode layer2 MULTIPLY-MODE))
	; Color (Red-Cyan)
      ((= type 3)
        (gimp-levels layer1  BLUE-LUT 0 255 1.00 255 255)
        (gimp-levels layer1 GREEN-LUT 0 255 1.00 255 255)
        (gimp-levels layer2   RED-LUT 0 255 1.00 255 255)
        (gimp-layer-set-opacity layer1 100)
        (gimp-layer-set-opacity layer2 100)
        (gimp-layer-set-mode layer1 NORMAL-MODE)
        (gimp-layer-set-mode layer2 MULTIPLY-MODE))
	; Interleave LC-Shutter
      ((= type 4)
        (plug-in-grid 1 image layer1 0 2 0 WHITE 255
                                     1 2 1 WHITE 255 0 0 0 WHITE 255)
        (plug-in-grid 1 image layer2 0 2 0 WHITE 255
                                     1 2 0 WHITE 255 0 0 0 WHITE 255)
        (gimp-layer-set-opacity layer2 100)
        (gimp-layer-set-opacity layer1 100)
        (gimp-layer-set-mode layer1 NORMAL-MODE)
        (gimp-layer-set-mode layer2 MULTIPLY-MODE))
      ('else (gimp-message "Error in Type!!"))
    ) ; end of cond
  ) ; end of let*
) ; end of define









	;; AiOtXNvg (̃C[W}bvgăAiOt)

(define (script-fu-anaglyph-one-map
			img		;; Ώۉ摜
			drawable	;; ΏۃC[
			map		;; }bv摜
			type		;; AiOt̎
			amount		;; ̗
	)

  (gimp-undo-push-group-start img)

  (let* (
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-selection (car (gimp-selection-save img)))
         (color-layer1 (car (gimp-layer-copy drawable TRUE)))
         (color-layer2 (car (gimp-layer-copy drawable TRUE)))
         (map-width (car (gimp-drawable-width map)))
         (map-height (car (gimp-drawable-height map)))
         (drawable-width (car (gimp-drawable-width drawable)))
         (drawable-height (car (gimp-drawable-height drawable)))
         (scaled-map (car (gimp-layer-new img map-width map-height RGBA_IMAGE
                                          "Temp Layer" 100 NORMAL-MODE)))
	) ; end variable definition

	;; FC[ǉ
    (gimp-image-add-layer img color-layer1 -1)
    (gimp-image-add-layer img color-layer2 -1)

	;; FC[ɂ炵s
    (gimp-edit-copy map)
    (gimp-floating-sel-anchor (car (gimp-edit-paste scaled-map 0)))
   ; (gimp-floating-sel-attach scaled-map map)
   ; (gimp-floating-sel-anchor (car (gimp-image-floating-selection img)))
    (gimp-layer-scale scaled-map drawable-width drawable-height 0)
    (gimp-selection-load old-selection)
    (gimp-levels scaled-map VALUE-LUT 0 255 1.00 127 255)
    (plug-in-displace 1 img color-layer1    amount  0 TRUE FALSE scaled-map scaled-map 1)
    (plug-in-displace 1 img color-layer2 (- amount) 0 TRUE FALSE scaled-map scaled-map 1)

	;; AiOtKp
    (anaglyph-maker img color-layer1 color-layer2 type)

	;; Ï悪ꍇ̏
    (if (eqv? (car (gimp-selection-is-empty img)) FALSE)
        (begin
          (gimp-selection-invert img)
          (gimp-edit-clear color-layer1)
          (gimp-edit-clear color-layer2)
          (gimp-selection-invert img)))

	;; ̈悪Ƃ̏
   ; (set! final-layer (car (gimp-image-merge-down img color-layer2 EXPAND-AS-NECESSARY)))
   ; (if (eqv? (car (gimp-drawable-has-alpha drawable)) TRUE)
   ;     (gimp-selection-layer-alpha drawable))
   ; (if (eqv? (car (gimp-selection-is-empty img)) FALSE)
   ;     (begin
   ;       (gimp-selection-invert img)
   ;       (gimp-edit-clear final-layer)))
   ; (gimp-selection-load old-selection)
   ; (gimp-edit-copy final-layer)
   ; (gimp-image-remove-layer img final-layer)
   ; (gimp-floating-sel-anchor (car (gimp-edit-paste drawable 0)))
   ; (gimp-selection-load old-selection)
   ; (gimp-image-remove-channel img old-selection)

	;; ㏈
    (gimp-palette-set-foreground old-fg)
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
  ) ; end of let*
) ; end of define

(script-fu-register
  "script-fu-anaglyph-one-map"
  "<Image>/Script-Fu/Utils/Anaglyph..."
  "Create anaglyph image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  "RGB*"
  SF-IMAGE       "Image"	0
  SF-DRAWABLE    "Drawable"	0
  SF-DRAWABLE    "Map Image"    0
  SF-OPTION      "Type"         '("Gray (Red-Cyan)"
                                  "Red-Green"
                                  "Red-Blue"
                                  "Color (Red-Cyan)"
                                  "Interleave")
  SF-ADJUSTMENT  _"Amount of Displace"	'(10 1 1200 1 10 0 1)
)









	;; AiOtXNvg (j̃C[WpăAiOt)

(define (script-fu-anaglyph-two-layer
			drawable-right	;; EC[
			drawable-left	;; C[
			type		;; AiOt̎
	)

  (let* (
	 (old-fg (car (gimp-palette-get-foreground)))
         (right-width  (car (gimp-drawable-width  drawable-right)))
         (right-height (car (gimp-drawable-height drawable-right)))
         (left-width   (car (gimp-drawable-width  drawable-left)))
         (left-height  (car (gimp-drawable-height drawable-left)))
         (right-name (car (gimp-layer-get-name drawable-right)))
         (left-name  (car (gimp-layer-get-name drawable-left)))
         (max-width  (if (> right-width  left-width)  right-width  left-width))
         (max-height (if (> right-height left-height) right-height left-height))
         (img (car (gimp-image-new max-width max-height RGB)))
         (layer-right (car (gimp-layer-new img right-width right-height
                                           RGBA_IMAGE right-name 100 NORMAL)))
         (layer-left  (car (gimp-layer-new img  left-width  left-height
                                           RGBA_IMAGE  left-name 100 NORMAL)))
	) ; end variable definition

    (gimp-image-undo-disable img)

	;; C[ǉ
    (gimp-drawable-fill layer-right TRANS-IMAGE-FILL)
    (gimp-drawable-fill layer-left  TRANS-IMAGE-FILL)
    (gimp-edit-copy drawable-right)
    (gimp-floating-sel-anchor (car (gimp-edit-paste layer-right 0)))
    (gimp-edit-copy drawable-left)
    (gimp-floating-sel-anchor (car (gimp-edit-paste layer-left  0)))
    (gimp-image-add-layer img layer-left  -1)
    (gimp-image-add-layer img layer-right -1)

	;; AiOtKp
    (anaglyph-maker img layer-left layer-right type)

	;; ㏈
    (gimp-palette-set-foreground old-fg)
    (gimp-image-undo-enable img)
    (gimp-display-new img)
    (gimp-displays-flush)
  ) ; end of let*
) ; end of define

(script-fu-register
  "script-fu-anaglyph-two-layer"
  "<Toolbox>/Xtns/Script-Fu/Utils/Anaglyph..."
  "Create anaglyph image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  ""
  SF-DRAWABLE    "Right Image"   0
  SF-DRAWABLE    "Letf Image"    2
  SF-OPTION      "Type"         '("Gray (Red-Cyan)"
                                  "Red-Green"
                                  "Red-Blue"
                                  "Color (Red-Cyan)"
                                  "Interleave")
)
