; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; AquaPro script  for GIMP 1.2
;
; The original Perl-Fu script was written by Denis Bodor <b.bodor@calixo.net>
;   - http://www.linuxmag-france.org/redactor_zone/aquapl.html
;
; Translated into Script-Fu by Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 1.0  by Iccii 2001/09/14
;     - Initial relase
;
; --------------------------------------------------------------------
; 
; #################################################################################
; #
; # aquabou.pl
; # A Gimp Perl-Fu that create a Aqua Style Button 
; #
; # Copyright (C) 2001 Denis Bodor <b.bodor@calixo.net>
; #
; # This program is free software; you can redistribute it and/or 
; # modify it under the terms of the GNU General Public License   
; # as published by the Free Software Foundation; either version 2
; # of the License, or (at your option) any later version.
; #
; # This program is distributed in the hope that it will be useful,
; # but WITHOUT ANY WARRANTY; without even the implied warranty of
; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; # GNU General Public License for more details.
; #
; # You should have received a copy of the GNU General Public License
; # along with this program; if not, write to the Free Software
; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
; #
; #################################################################################


(define (script-fu-aqua-button
			coulfg
			coulbg)


  (define (selzone img)
    (gimp-ellipse-select img 40 40 176 176 REPLACE TRUE 0 0)
    (gimp-ellipse-select img 296 40 176 176 ADD TRUE 0 0)
    (gimp-rect-select img 128 40 256 176 ADD 0 0)
  )


  (let* (
	 (width 512)
	 (height 286)
	 (WHITE '(255 255 255))
	 (BLACK '(  0   0   0))
	 (image (car (gimp-image-new width height RGB)))
	;; Set new selections for the fore and background-color.
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (fond (car (gimp-layer-new image width height RGB_IMAGE
	                                  "Background" 100 NORMAL-MODE)))
	 (base (car (gimp-layer-new image width height RGBA_IMAGE
	                                  "Base" 90 NORMAL-MODE)))
	 (ombre (car (gimp-layer-new image width height RGBA_IMAGE
	                                   "Shadow" 70 NORMAL-MODE)))
	 (reflh (car (gimp-layer-new image width height RGBA_IMAGE
	                                   "Top Reflect" 80 SCREEN-MODE)))
	 (lum (car (gimp-layer-new image width height RGBA_IMAGE
	                                 "light" 100 OVERLAY-MODE)))
	)


    (gimp-image-undo-disable image)
    (gimp-palette-set-foreground coulfg)
    (gimp-palette-set-background WHITE)

    (gimp-image-add-layer image reflh 0)
    (gimp-image-add-layer image lum   1)
    (gimp-image-add-layer image base  2)
    (gimp-image-add-layer image ombre 3)
    (gimp-image-add-layer image fond  4)

    (gimp-edit-clear reflh)
    (gimp-edit-clear lum)
    (gimp-edit-clear base)
    (gimp-edit-clear ombre)
    (gimp-edit-clear fond)

	;; fill the background
    (gimp-palette-set-foreground coulbg)
    (gimp-edit-fill fond FG-IMAGE-FILL)

	;; make base of the button
    (set! maskbase (car (gimp-layer-create-mask base ALPHA-MASK)))
    (gimp-edit-clear maskbase)

    (gimp-palette-set-foreground WHITE)
    (gimp-edit-fill maskbase FG-IMAGE-FILL)
    (selzone image)
    (gimp-palette-set-foreground coulfg)
    (gimp-edit-fill base FG-IMAGE-FILL)

    (gimp-selection-shrink image 58)
    (gimp-palette-set-foreground '(160 160 160))
    (gimp-edit-fill maskbase FG-IMAGE-FILL)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image maskbase 74 74)
    (gimp-image-add-layer-mask image base maskbase)
    (gimp-channel-set-visible maskbase FALSE)


	;; Make shadow
    (selzone image)
    (gimp-selection-translate image 0 50)
    (gimp-palette-set-foreground coulfg)
    (gimp-edit-fill ombre FG-IMAGE-FILL)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image ombre 44 44)
    (gimp-palette-set-foreground coulfg)

    (set! maskombre (car (gimp-layer-create-mask ombre ALPHA-MASK)))
    (gimp-edit-clear maskombre)
    (gimp-palette-set-foreground BLACK)
    (gimp-edit-fill maskombre FG-IMAGE-FILL)
    (selzone image)
    (gimp-selection-invert image)
    (gimp-edit-clear maskombre)
    (gimp-image-add-layer-mask image ombre maskombre)
    (gimp-channel-set-visible maskombre FALSE)

	;; make light
    (gimp-selection-none image)
    (gimp-palette-set-foreground BLACK)
    (gimp-edit-fill lum FG-IMAGE-FILL)
    (selzone image)
    (gimp-selection-shrink image 30)
    (gimp-selection-translate image 0 45)
    (gimp-palette-set-foreground WHITE)
    (gimp-edit-fill lum FG-IMAGE-FILL)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image lum 50 50)


	;; Top reflect
    (gimp-rect-select image 122 50 268 40 REPLACE 0 0)
    (set! chacha (car (gimp-selection-save image)))
    (gimp-selection-none image)
    (plug-in-gauss-iir TRUE image chacha 36 TRUE TRUE)
    (gimp-levels chacha VALUE-LUT 123 133 1.0 0 255)
    (gimp-selection-load chacha)
    (gimp-image-remove-channel image chacha)
    (gimp-palette-set-foreground BLACK)
    (gimp-blend reflh FG-BG-HSV NORMAL-MODE LINEAR 100 0
                      REPEAT-NONE FALSE 0 0 256 97 256 50)
    (gimp-perspective reflh FALSE 122 50 390 50 80 90 432 90)
    (gimp-floating-sel-anchor (car (gimp-image-floating-selection image)))


    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-image-undo-enable image)
    (gimp-display-new image)
    (gimp-displays-flush)

    image	; Return

  ) ; end of let*
)


(script-fu-register
	"script-fu-aqua-button"
	"<Toolbox>/Xtns/Script-Fu/Buttons/AquaPro..."
	"Creates a aqua-style button\n
This script creates a multi-layered aqua button. Thx to Wolfgang Mauerer."
	"Denis Bodor"
	"lefinnois@lefinnois.net"
	"0.0"
	""
	SF-COLOR	"Foreground Color"	'( 71 124 183)
	SF-COLOR	"Background Color"	'(  0   0   0)
)
