; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; AquaPro script  for GIMP 1.2
;
; The original Perl-Fu script was written by Denis Bodor <b.bodor@calixo.net>
;   - http://www.linuxmag-france.org/redactor_zone/aquapl.html
;
; Translated into Script-Fu by Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 1.0  by Iccii 2001/09/14
;     - Initial relase (aquabou.scm)
; version 1.1  by Iccii 2001/09/17
;     - Second relase (aquabou2.scm)
;     - Add the setting options which enable adjustment Width and Height
; version 1.1a by Iccii 2001/11/01
;     - Fixed wrong parameter name ...Thanks to _tom_
; version 1.2  by Iccii 2001/11/02
;     - Added creating logo in aqua pill (script-fu-aqua-button2-logo)
;     - Note that this relase has bugs in some situation
; version 1.2a by Iccii 2001/11/06
;     - Fixed above bugs
;     - Moved menu path in <Xtns>/Script-Fu/Web Page Themes/AquaPro2/*
; version 1.3  by Iccii 2001/11/07
;     - Added new image creation function (script-fu-aquapro2-round)
;     - Added new image creation function (script-fu-aquapro2-logo-in-ball)
;     - Changed the top reflecting fusion
; version 1.3a by Iccii 2001/11/08
;     - Now, script-fu-aquapro2-logo-in-ball function allows white space
;       in string to split into each balls per words
; version 1.3b by Iccii 2001/11/09
;     - Adjusted the top highlight reflection (looks better)
;
; --------------------------------------------------------------------
; 
; #################################################################################
; #
; # aquabou.pl
; # A Gimp Perl-Fu that create a Aqua Style Button 
; #
; # Copyright (C) 2001 Denis Bodor <b.bodor@calixo.net>
; #
; # This program is free software; you can redistribute it and/or 
; # modify it under the terms of the GNU General Public License   
; # as published by the Free Software Foundation; either version 2
; # of the License, or (at your option) any later version.
; #
; # This program is distributed in the hope that it will be useful,
; # but WITHOUT ANY WARRANTY; without even the implied warranty of
; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; # GNU General Public License for more details.
; #
; # You should have received a copy of the GNU General Public License
; # along with this program; if not, write to the Free Software
; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
; #
; #################################################################################



	;; Create aqua style button (connom function)
(define (script-fu-aqua-button2
			width
			height
			coulfg
			coulbg)

  (let* (
	 (xscale (/ width 512))
	 (yscale (/ height 286))
	 (radius2 (max (/ (min (* yscale 176) (* xscale 432)) 2) 2))
	 (WHITE '(255 255 255))
	 (BLACK '(  0   0   0))
	 (image (car (gimp-image-new width height RGB)))
	;; Set new selections for the fore and background-color.
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (fond (car (gimp-layer-new image width height RGB_IMAGE
	                                  "Background" 100 NORMAL-MODE)))
	 (base (car (gimp-layer-new image width height RGBA_IMAGE
	                                  "Base" 90 NORMAL-MODE)))
	 (ombre (car (gimp-layer-new image width height RGBA_IMAGE
	                                   "Shadow" 70 NORMAL-MODE)))
	 (reflh (car (gimp-layer-new image width height RGBA_IMAGE
	                                   "Top Reflect" 80 SCREEN-MODE)))
	 (lum (car (gimp-layer-new image width height RGBA_IMAGE
	                                 "light" 100 OVERLAY-MODE)))
	) ; end variable definition


    (define (selzone img)
      (if (> width height)
          (let* ((maxscale (max xscale yscale))
                 (minscale (min xscale yscale))
                 (diffscale (- maxscale minscale)))
             (gimp-ellipse-select img (*  40 xscale) (*  40 yscale)
                             (* 2 radius2) (* 2 radius2) REPLACE TRUE 0 0)
             (gimp-ellipse-select img (- (* 472 xscale) (* 2 radius2)) (*  40 yscale)
                             (* 2 radius2) (* 2 radius2) ADD TRUE 0 0)
             (gimp-rect-select img (+ (* 40 xscale) radius2) (*  40 yscale)
                             (- (* 432 xscale) (* 2 radius2)) (* 2 radius2) ADD 0 0))
           (gimp-ellipse-select img (*  40 xscale) (*  40 yscale)
                             (* 432 xscale) (* 176 yscale) REPLACE TRUE 0 0)
      ))


    (gimp-image-undo-disable image)
    (gimp-palette-set-foreground coulfg)
    (gimp-palette-set-background WHITE)

    (gimp-image-add-layer image reflh 0)
    (gimp-image-add-layer image lum   1)
    (gimp-image-add-layer image base  2)
    (gimp-image-add-layer image ombre 3)
    (gimp-image-add-layer image fond  4)

    (gimp-edit-clear reflh)
    (gimp-edit-clear lum)
    (gimp-edit-clear base)
    (gimp-edit-clear ombre)
    (gimp-edit-clear fond)

	;; fill the background
    (gimp-palette-set-foreground coulbg)
    (gimp-edit-fill fond FG-IMAGE-FILL)

	;; make base of the button
    (set! maskbase (car (gimp-layer-create-mask base ALPHA-MASK)))
    (gimp-edit-clear maskbase)

    (gimp-palette-set-foreground WHITE)
    (gimp-edit-fill maskbase FG-IMAGE-FILL)
    (selzone image)
    (gimp-palette-set-foreground coulfg)
    (gimp-edit-fill base FG-IMAGE-FILL)

    ;(gimp-selection-shrink image (* 58 scale))
    (gimp-selection-shrink image (/ radius2 1.52))
    (gimp-palette-set-foreground '(160 160 160))
    (gimp-edit-fill maskbase FG-IMAGE-FILL)
    (gimp-selection-none image)
    ;(plug-in-gauss-rle2 TRUE image maskbase (* 74 xscale) (* 74 yscale))
    (plug-in-gauss-rle2 TRUE image maskbase (/ radius2 1.19) (/ radius2 1.19))
    (gimp-image-add-layer-mask image base maskbase)
    (gimp-channel-set-visible maskbase FALSE)

	;; Make shadow
    (selzone image)
    (gimp-selection-translate image 0 (* 50 yscale))
    (gimp-palette-set-foreground coulfg)
    (gimp-edit-fill ombre FG-IMAGE-FILL)
    (gimp-selection-none image)
    ;(plug-in-gauss-rle2 TRUE image ombre (* 44 xscale) (* 44 yscale))
    (plug-in-gauss-rle2 TRUE image ombre (/ radius2 (+ 2.00 0.5)) (/ radius2 (+ 2.00 0.5)))
    (gimp-palette-set-foreground coulfg)

    (set! maskombre (car (gimp-layer-create-mask ombre ALPHA-MASK)))
    (gimp-edit-clear maskombre)
    (gimp-palette-set-foreground BLACK)
    (gimp-edit-fill maskombre FG-IMAGE-FILL)
    (selzone image)
    (gimp-selection-invert image)
    (gimp-edit-clear maskombre)
    (gimp-image-add-layer-mask image ombre maskombre)
    (gimp-channel-set-visible maskombre FALSE)

	;; make light
    (gimp-selection-none image)
    (gimp-palette-set-foreground BLACK)
    (gimp-edit-fill lum FG-IMAGE-FILL)
    (selzone image)
    ;(gimp-selection-shrink image (* 30 scale))
    (gimp-selection-shrink image (/ radius2 2.92))
    (gimp-selection-translate image 0 (* 45 yscale))
    (gimp-palette-set-foreground WHITE)
    (gimp-edit-fill lum FG-IMAGE-FILL)
    (gimp-selection-none image)
    ;(plug-in-gauss-rle2 TRUE image lum (* 50 xscale) (* 50 yscale))
    (plug-in-gauss-rle2 TRUE image lum (/ radius2 (+ 1.76 0.5)) (/ radius2 (+ 1.76 0.5)))


	;; Top reflect
    (gimp-selection-none image)
    (if (> width height)
        (begin
          (gimp-ellipse-select image (+ (*  40 xscale) (* 0.6 radius2)) (*  40 yscale)
                                     (* 0.6 radius2)   (* 0.6 radius2) REPLACE TRUE 0 0)
          (gimp-ellipse-select image (- (* 472 xscale) (* 1.2 radius2)) (*  40 yscale)
                                     (* 0.6 radius2)   (* 0.6 radius2) ADD TRUE 0 0)
          (gimp-rect-select image
                            (+ (*  40 xscale) (* radius2 0.9)) (*  40 yscale)
                            (- (* 432 xscale) (* radius2 1.8)) (* 0.6 radius2) ADD 0 0))
        (begin
          (gimp-ellipse-select image
                               (+ (*  40 xscale) (* 0.2 radius2)) (*  40 yscale)
                               (- (* 432 xscale) (* 0.4 radius2)) (* 176 yscale 0.3)
                               REPLACE TRUE 0 0)))
;(gimp-display-new image)
;(gimp-message 1)
    (gimp-palette-set-foreground BLACK)
    (gimp-drawable-fill reflh TRANS-IMAGE-FILL) 
    (gimp-blend reflh FG-BG-HSV NORMAL-MODE LINEAR 100 0
                      REPEAT-NONE FALSE 0 0 (* 256 xscale) (* (- 97 10) yscale)
                                            (* 256 xscale) (* (- 50 10) yscale))
    (gimp-perspective reflh FALSE
                      (+ (* (- 122 70) xscale) (* 0.6 radius2))  (* 50 yscale 1.0)
                      (- (* (+ 390 70) xscale) (* 0.6 radius2))  (* 50 yscale 1.0)
                      (+ (* (-  80 50) xscale) (* 0.6 radius2))  (* 90 yscale 1.0)
                      (- (* (+ 432 50) xscale) (* 0.6 radius2))  (* 90 yscale 1.0))
;(gimp-message 1)
    (gimp-floating-sel-anchor (car (gimp-image-floating-selection image)))


    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-image-undo-enable image)
    (list image (car (gimp-display-new image)))	; Return '(image display)

  ) ; end of let*
)









	;; Ceate an aqua button (aqua button without text)

(define (script-fu-aquapro2-hrule
			width
		 	height
			fg-color
			bg-color
			pill?)
  (if (eqv? pill? TRUE)
      (script-fu-aqua-button2 (/ (* width 512) 432)
                              (/ (* height 286) 176) fg-color bg-color)
      (script-fu-aqua-button2 width height fg-color bg-color)))

(script-fu-register
	"script-fu-aquapro2-hrule"
	"<Toolbox>/Xtns/Script-Fu/Web Page Themes/AquaPro2/Hrule..."
	"Creates a aqua-style button\n
This script creates a multi-layered aqua button. Thx to Wolfgang Mauerer."
	"Denis Bodor"
	"lefinnois@lefinnois.net"
	"0.0"
	""
	SF-ADJUSTMENT	"Width"			'(512  32 9999 1 10 0 1)
	SF-ADJUSTMENT	"Height"		'(286  32 9999 1 10 0 1)
	SF-COLOR	"Foreground Color"	'( 71 124 183)
	SF-COLOR	"Background Color"	'(  0   0   0)
	SF-TOGGLE	"Pill's Width and Height?" FALSE
)










	;; Ceate a round image

(define (script-fu-aquapro2-round
			baseradius
			fg-color
			bg-color)
      (script-fu-aqua-button2 (/ (* baseradius (* 512 2)) 432)
                              (/ (* baseradius (* 286 2)) 176) fg-color bg-color))

(script-fu-register
	"script-fu-aquapro2-round"
	"<Toolbox>/Xtns/Script-Fu/Web Page Themes/AquaPro2/Round..."
	"Creates a aqua-style round button"
	"Iccii <iccii@hotmail.com>"
	"Iccii"
	"2001, Nov"
	""
	SF-ADJUSTMENT	_"Base Radius (pixel)"	'(60 2 1024 1 1 0 1)
	SF-COLOR	"Foreground Color"	'( 71 183 124)
	SF-COLOR	"Background Color"	'(255 255 255)
)









	;; Create an aqua button with text

(define (script-fu-aquapro2-button
			text
		 	size
			fontname
			text-color
			fg-color
			bg-color
			add-shadow?)
  (let* (
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
         (img (car (gimp-image-new 256 256 RGB)))
         (x-padding (/ size 3.5))
         (y-padding (/ size 3.5))
	) ; end variable definition

    (gimp-image-undo-disable img)
    (gimp-palette-set-foreground text-color)
    (let* (
           (text-layer (car (gimp-text-fontname img -1 0 0 text 0 TRUE
                                                size PIXELS fontname)))
           (layer-width (car (gimp-drawable-width text-layer)))
           (layer-height (car (gimp-drawable-height text-layer)))
          )
      (gimp-image-resize img layer-width layer-height 0 0)
      (gimp-layer-set-name text-layer text text)
      (set! listed (script-fu-aqua-button2 (* (+ (* 2 x-padding) layer-width)  (/ 512 432))
                                           (* (+ (* 2 y-padding) layer-height) (/ 286 176))
                                           fg-color bg-color))
      (set! image (car listed))
      (gimp-edit-copy text-layer)
    )
    (gimp-image-undo-disable image)
    (let* (
           (image-width (car (gimp-image-width image)))
           (image-height (car (gimp-image-height image)))
           (new-text-layer (car (gimp-layer-new image image-width image-height
                                                RGBA_IMAGE text 100 NORMAL)))
          )
      (gimp-drawable-fill new-text-layer TRANS-IMAGE-FILL)
      (gimp-image-add-layer image new-text-layer -1)
      (gimp-image-lower-layer image new-text-layer)
      (gimp-rect-select image (* image-width (/  40 512)) (* image-height (/  40 286))
                              (* image-width (/ 432 512)) (* image-height (/ 176 286))
                              ADD 0 0)
      (gimp-floating-sel-anchor (car (gimp-edit-paste new-text-layer TRUE)))
      (gimp-selection-none image)
      (if (eqv? add-shadow? TRUE)
          (let* (
                 (text-copy (car (gimp-layer-copy new-text-layer TRUE)))
                )
            (gimp-image-add-layer image text-copy -1)
            (gimp-image-lower-layer image text-copy)
            (gimp-image-lower-layer image text-copy)
            (gimp-image-lower-layer image text-copy)
            (gimp-channel-ops-offset text-copy TRUE OFFSET-TRANSPARENT
                                     (/ size 32) (/ size 8))
            (plug-in-gauss-iir2 1 image text-copy (/ size 9) (/ size 9))
      ))
      (gimp-image-set-active-layer image new-text-layer)
    )
    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-image-undo-enable image)
    (gimp-image-undo-enable img)
    (gimp-displays-flush)

    listed	; Return '(image display)
))

(script-fu-register
  "script-fu-aquapro2-button"
  "<Toolbox>/Xtns/Script-Fu/Web Page Themes/AquaPro2/Butoon..."
  "Create the logo in aqua pill image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  ""
  SF-STRING	_"Text"			"Aqua"
  SF-ADJUSTMENT	_"Font Size (pixels)"	'(100 2 500 1 1 0 1)

  SF-FONT	_"Font"
	; Checking winsnap plug-in (Windows or not?)
(if (symbol-bound? 'extension-winsnap (the-environment))
	; For Windows user
		"-*-Times New Roman-bold-r-*-*-24-*-*-*-p-*-iso8859-1"
	; Default setting
		"-*-classicheavylight-*-r-*-*-24-*-*-*-p-*-*-*"
)
  SF-COLOR      _"Text Color"		'(  0   0   0)
  SF-COLOR      _"Base Color"		'(183  71 124)
  SF-COLOR      _"Background Color"	'(255 255 255)
  SF-TOGGLE	_"Add Drop-Shadow"	TRUE
)









	;; Create logo in aqua ball

(define (script-fu-aquapro2-logo-in-ball
			text
		 	size
			fontname
			text-color
			fg-color
			bg-color
			add-shadow?
			apply-lens?
			flatten?)

	; text ̍E󔒂菜
  (set! text (string-trim text))

	; ꕶ str 󔒂ł邩ǂ𔻒
  (define (white-space-string? str)
    (or (equal? " " str) (equal? "	" str)))

	; strings ̒ɋ󔒃Xy[X TRUE Ԃ
  (define (string-have-white-space? strings)
    (let* ((text-length (string-length strings))
           (have-white-space? FALSE))
      (let ((n 0))
        (while (< n text-length)
          (if (white-space-string? (substring strings n (+ n 1)))
              (set! have-white-space? TRUE))
          (set! n (+ n 1))))
     have-white-space?))	; Return (let*)

	; start  text 𐔂ĈԎn߂ɏo󔒃Xy[ẌʒuԂ
  (define (count-next-space start)
    (let* ((n start)
           (hantei 1)
           (text-length (string-length text)))
      (if (eqv? (string-have-white-space? (substring text start text-length)) TRUE)
          (begin
            (while (not (white-space-string? (substring text n (+ n 1))))
              (set! n (+ n 1)))
            (- n start))
          (- text-length start))))

  (let* (
	 (old-bg (car (gimp-palette-get-background)))
	; ŏɓyƂȂ摜邽߁Aŏ̈ꕶ
	; RAꍇ̓XNvg̓G[ƂȂ
         (img (car (gimp-image-new 1 1 RGB)))
         (text-length (string-length text))
         (count 0)
	) ; end variable definition
    (gimp-palette-set-background bg-color)
	; ̒ɒB܂ŃJEg
    (while (< count text-length)
      (let* (
	;  text  count Ԗڂ̈ꕶ̃ANA摜
             (string-step (if (eqv? (string-have-white-space? text) TRUE)
                              (count-next-space count)
                              1))
             (listed (script-fu-aquapro2-button (substring text count (+ count string-step))
                                  size fontname text-color fg-color bg-color add-shadow?))
             (image (car listed))
             (image-width (car (gimp-image-width image)))
             (image-height (car (gimp-image-height image)))
             (img-width (car (gimp-image-width img)))
             (img-height (car (gimp-image-height img)))
             (img-layer (car (gimp-layer-new img image-width (max img-height image-height)
                                             RGBA_IMAGE
                                             (substring text count (+ count string-step))
                                             100 NORMAL-MODE)))
            )
;(gimp-message (number->string string-step))
	; x[XƂȂ摜̍ǉ摜̍傫ꍇɂ
	; ǉ摜̍x[X̍ɍ킹A̒ɔzu (TCY)
	; At̏ꍇ̓x[X摜̍ǉ摜̍ɍ킹Aʒu𒲐
        (if (< img-height image-height)
            (begin
              (set! height-mean2 0)
              (set! height-mean1 (/ (- image-height img-height) 2))
              (set! img-height image-height))
            (begin
              (set! height-mean1 0)
              (set! height-mean2 (/ (- img-height image-height) 2))))
        (gimp-image-resize img (+ img-width image-width) img-height 0 height-mean1)
        (gimp-image-resize image image-width img-height 0 height-mean2)
        (if (equal? apply-lens? TRUE)
            (let ((lens-layer (car (gimp-image-get-active-layer image))))
              (plug-in-applylens 1 image lens-layer 1.2 TRUE TRUE FALSE)))
     ;   (if (= count 0)
     ;       (gimp-crop img (- image-width 1) img-height 0 0))
        (set! image-layer (car (gimp-image-flatten image)))
	; x[X摜ɒǉ̂߂̃C[ǉAʒu킹Ă當̑}
        (gimp-image-add-layer img img-layer -1)
        (gimp-layer-set-offsets img-layer img-width 0)
        (gimp-edit-copy image-layer)
        (gimp-floating-sel-anchor (car (gimp-edit-paste img-layer 0)))
	; vȂȂǉ摜폜
        (gimp-display-delete (cadr listed))
	; count++ āA̕󔒂ł΋󔒂ŖȂ܂ count 
        (set! count (+ count string-step)))
        (if (and (< count text-length)
                 (white-space-string? (substring text count (+ count 1))))
            (set! count (+ count 1)))
      ) ; end of let*
      (if (eqv? flatten? TRUE)
          (gimp-image-flatten img))
    (gimp-palette-set-background old-bg)
    (gimp-displays-flush)

    (list img (car (gimp-display-new img)))		; Return '(image display)
))

(script-fu-register
  "script-fu-aquapro2-logo-in-ball"
  "<Toolbox>/Xtns/Script-Fu/Web Page Themes/AquaPro2/Logo in Ball..."
  "Create the image which each logos is in each aqua balls"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Nov"
  ""
  SF-STRING	_"Text"			"012 - 345"
  SF-ADJUSTMENT	_"Font Size (pixels)"	'(75 2 500 1 1 0 1)

  SF-FONT	_"Font"
	; Checking winsnap plug-in (Windows or not?)
(if (symbol-bound? 'extension-winsnap (the-environment))
	; For Windows user
		"-*-Times New Roman-bold-r-*-*-24-*-*-*-p-*-iso8859-1"
	; Default setting
		"-*-classicheavylight-*-r-*-*-24-*-*-*-p-*-*-*"
)
  SF-COLOR      _"Text Color"		'(  0   0   0)
  SF-COLOR      _"Base Color"		'(124 183  71)
  SF-COLOR      _"Background Color"	'(255 255 255)
  SF-TOGGLE	_"Add Drop-Shadow"	TRUE
  SF-TOGGLE	"Apply Lens?"		FALSE
  SF-TOGGLE	_"Flatten Image"	TRUE
)
