; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Channel exchanger (RGB, HSV, CMY) script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/10/20
;     - Initial relase
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; `ľXNvg
(define (script-fu-channel-exchanger
			img		;; Ώۉ摜
			layer		;; ΏۃC[
			type		;; ̎
	)

	;; ̎ނɉK؂ȉ摜Ԃ
  (define (get-exchanged-channel img-list channel-no)
    (define (list-ref l n) (nth n l))
    (let* (
	   (no (cond
	         ((and (<= 0 type) (<= type 5)) channel-no)
	         ((or (= type 6) (= type  9) (= type 12))
	           (cond ((= channel-no 0) 1) ((= channel-no 1) 0) ((= channel-no 2) 2)))
	         ((or (= type 7) (= type 10) (= type 13))
	           (cond ((= channel-no 0) 0) ((= channel-no 1) 2) ((= channel-no 2) 1)))
	         ((or (= type 8) (= type 11) (= type 14))
	           (cond ((= channel-no 0) 2) ((= channel-no 1) 1) ((= channel-no 2) 0))) ))
	  )
      (list-ref img-list no)))

  (let* (
	 (decompose-type (cond ((or (= type 0) (= type 5)
	                            (and (<= 6 type) (<= type 8))) "RGB")
	                       ((or (= type 1) (= type 2)
	                            (and (<= 9 type) (<= type 11))) "HSV")
	                       ((or (= type 3) (= type 4)
	                            (and (<= 12 type) (<= type 14))) "CMY") ))
	 (compose-type (cond ((or (= type 1) (= type 4)
	                          (and (<= 6 type) (<= type 8))) "RGB")
	                     ((or (= type 0) (= type 3)
	                          (and (<= 9 type) (<= type 11))) "HSV")
	                     ((or (= type 2) (= type 5)
	                          (and (<= 12 type) (<= type 14))) "CMY") ))
	 (decompose-result (plug-in-decompose 1 img layer decompose-type))
	 (image1 (get-exchanged-channel decompose-result 0))
	 (image2 (get-exchanged-channel decompose-result 1))
	 (image3 (get-exchanged-channel decompose-result 2))
	 (image4 FALSE)
	 (result-img (car (plug-in-compose 1 image1 layer
	                                   image2 image3 image4 compose-type)))
        )

	;; ㏈
    (gimp-display-new result-img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-channel-exchanger"
  "<Image>/Script-Fu/Utils/Channel Exchanger..."
  "Exchange the image's channel (RGB, HSV, CMY)"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  "RGB*"
  SF-IMAGE      "Image"		    0
  SF-DRAWABLE   "Drawable"	    0
  SF-OPTION     "Exchange channel"  '("RGB -> HSV"  "RGB <- HSV"
                                      "HSV -> CMY"  "HSV <- CMY"
                                      "CMY -> RGB"  "CMY <- RGB"

                                      "Red <-> Green"
                                      "Green <-> Blue"
                                      "Blue <-> Red"

                                      "Hue <-> Saturation"
                                      "Saturation <-> Value"
                                      "Value <-> Hue"

                                      "Cyan <-> Magenta"
                                      "Magenta <-> Yellow"
                                      "Yellow <-> Cyan")
)
