; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Dotted Chaos --- create an dotted chaos (sample version)
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
;   - Changelog -
; version 0.1  2001/05/16 iccii <iccii@hotmail.com>
;     - Initial relase
; version 0.1a 2001/05/16 iccii <iccii@hotmail.com>
;     - Fix the memory leak
; version 0.2  2001/05/17 iccii <iccii@hotmail.com>
;     - Add the adjuster of initial parameter x0, x0, a
;     - Add the Changing and Curve line in chaos type
; version 0.3  2001/05/18 iccii <iccii@hotmail.com>
;     - Add the adjuster of initial parameter scale for Stitch2
;     - Add the Independent in chaos type
;     - Use the gimp-pencil function to dot... thanks, Mstk
; version 0.4  2001/05/18 iccii <iccii@hotmail.com>
;     - Add the Fixed point in chaos type
; version 0.4a 2001/05/20 iccii <iccii@hotmail.com>
;     - Make better
; version 0.5  2001/05/24 iccii <iccii@hotmail.com>
;     - Now I can change color and gradient
;     - Use gimp-drawable-set-pixel instead of gimp-pencil... thanks, Kajiyama
; version 0.5a 2001/06/13 iccii <iccii@hotmail.com>
;     - Add the "Use Gradient?" option to creat black/white image
; version 0.5b 2001/06/15 iccii <iccii@hotmail.com>
;     - Add the refarence book
;
; --------------------------------------------------------------------
;     Reference Book
; http://www.saiensu.co.jp/books-htm/ISBN4-7819-0729-6.htm
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


(define (script-fu-chaos-dotted-sample
			chaos-type	; JIX̎
			image-size	; 摜̑傫
			bg-color	; wiF
			gradient	; Of[VŃJIXɐFt
			use-gradient	; Of[Vgǂ
			iteration		; JԂ
			scale		; g嗦
			x0		; l x0
			y0		; l y0
			a		; p[^ a
	)

  (let* (
	 (modulo fmod)			; in R4RS way
	 (REPEAT_MAX 1000)
	 (count 0)
	 (color-change (/ iteration 255))
	 (u0 (/ image-size 2))
	 (v0 (/ image-size 2))
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-grad (car (gimp-gradients-get-active)))
	 (width image-size)
	 (height image-size)
	 (img (car (gimp-image-new width height RGB)))
	 (bg-layer (car (gimp-layer-new img width height RGB_IMAGE "Background" 100 NORMAL)))
	 (layer (car (gimp-layer-new img width height RGBA_IMAGE "Chaos" 100 NORMAL)))
	 (pixel (cons-array 4 'byte))
	)

	; JIX̎ޖɈقȂ鏉lZbgĂ܂
	; slx  sly ͂ꂼ摜 X,Y ̊g嗦
  (cond
    ((equal? chaos-type 0)
	;(set! x0 4.0)
	;(set! y0 0.0)
	(set! slx (/ u0 16))
	(set! sly (/ v0 16))
	(define (next-value x0 y0 a)
	  (let* ((x (+ y0 (* 0.2 x0) (/ (* 5.0 x0) (+ 1.0 (* x0 x0)) )) )
	         (y (- x0)))
	     (list x y))))
    ((equal? chaos-type 1)
	;(set! x0 0.5)
	;(set! y0 0.0)
	(set! slx (/ u0 9.5))
	(set! sly (/ v0 9.5))
	(define (next-value x0 y0 a)
	  (let* ((x (+ (- y0 (* 0.97 x0) 3.0) (/ 4.0 (+ 1.0 (* x0 x0)) ) ) )
	         (y (* (- 0.98) x0)))
	     (list x y))))
    ((equal? chaos-type 2)
	;(set! a 0.55)
	;(set! x0 4.0)
	;(set! y0 0.0)
	(set! slx (/ u0 scale))
	(set! sly (/ v0 scale))
	(define (next-value x0 y0 a)
	  (let* ((x (+ y0 (* a x0) (* 4.0 (atan x0)) ) )
	         (y (- x0)))
	     (list x y))))
    ((equal? chaos-type 3)
	;(set! a 0.55)
	;(set! x0 4.0)
	;(set! y0 0.0)
	(set! slx (/ u0 9))
	(set! sly (/ v0 9))
	(define (next-value x0 y0 a)
	  (let* ((x (+ y0 (* a x0) (/ (* 4.0 (atan x0)) (+ 1.0 (* x0 x0)) ) ) )
	         (y (- x0)))
	     (list x y))))
    ((equal? chaos-type 4)
	;(set! x0 4.0)
	;(set! y0 0.0)
	(set! slx (/ u0 100))
	(set! sly (/ v0 100))
	(define (next-value x0 y0 a)
	  (let* ((x (+ y0 (* a x0) (* 4 (atan y0))) )
	         (y (- (* 0.9 x0))))
	     (list x y))))
    ((equal? chaos-type 5)
	;(set! x0 4.0)
	;(set! y0 0.0)
	(set! slx (/ u0 22))
	(set! sly (/ v0 22))
	(define (next-value x0 y0 a)
	  (let* ((x (+ (* 0.55 x0) (* 0.9 y0) (atan y0)) )
	         (y (- x0)))
	     (list x y))))
    )

	(gimp-image-undo-disable img)
	(gimp-palette-set-foreground bg-color)
	(gimp-gradients-set-active gradient)
	(gimp-drawable-fill bg-layer FG-IMAGE-FILL)
	(gimp-drawable-fill layer TRANS-IMAGE-FILL)
	(gimp-image-add-layer img bg-layer -1)
	(gimp-image-add-layer img layer -1)

	; 烋[vn܂
	(while (< count iteration)
	  (set! listed-xy (next-value x0 y0 a))
	  (set! x (car  listed-xy))
	  (set! y (cadr listed-xy))
	  (set! x0 x)
	  (set! y0 y)
	  (cond
	    ((equal? chaos-type 0)
	        (set! u (+ u0 (* x slx)))
	        (set! v (- v0 (* y sly))))
	    ((equal? chaos-type 1)
	        (set! u (+ u0 (* x0 slx)))
	        (set! v (- v0 (* y0 sly))))
	    ((equal? chaos-type 2)
	        (set! u (+ u0 (* x0 slx)))
	        (set! v (- v0 (* y0 sly))))
	    ((equal? chaos-type 3)
	        (set! u (+ u0 (* x0 slx)))
	        (set! v (- v0 (* y0 sly))))
	    ((equal? chaos-type 4)
	        (set! u (+ u0 (* x0 slx)))
	        (set! v (+ v0 (* y0 sly))))
	    ((equal? chaos-type 5)
	        (set! u (+ u0 (* x0 slx)))
	        (set! v (+ v0 (* y0 sly)))) )
	  (let* ((color (if (eqv? use-gradient TRUE)
	                    (modulo (/ count color-change) 255)
	                    255)))
	    (aset pixel 0 color)
	    (aset pixel 1 color)
	    (aset pixel 2 color)
	    (aset pixel 3 255)
	    (if (and (<= 0 u) (<= u (- image-size 1)) (<= 0 v) (<= v (- image-size 1)))
	        (gimp-drawable-set-pixel layer u v 4 pixel)))

	  (set! count (+ count 1))
	)	; `惋[v̏I

	; nȂ
	(gimp-layer-set-preserve-trans layer TRUE)
	(if (eqv? use-gradient TRUE) (plug-in-gradmap 1 img layer))
	(gimp-layer-set-preserve-trans layer FALSE)
	(gimp-palette-set-foreground old-fg)
	(gimp-gradients-set-active old-grad)
	(gimp-image-undo-enable img)
	(gimp-display-new img)
	(gimp-displays-flush)
  )
)

	; o^
(script-fu-register
	"script-fu-chaos-dotted-sample"
	"<Toolbox>/Xtns/Script-Fu/Patterns/Chaos sample..."
	"create an chaos dotted (sample)"
	"Iccii <iccii@hotmail.com>"
	"Iccii"
	"Jun, 2001"
	""
	SF-OPTION	"Chaos Type"	'(
				"Stitch"	; Ԗږ͗l̃JIX
				"Wing"		; ̉Ȟ`JIX
				"Changing"	; lp[^ςē_
				"Curve line"	; sϋȐ̗݂
				"Fixed point"	; Œ_A_AgN^ƂȂ
				"Independent"	; ƗȕȐʑ̗
			)
	SF-ADJUSTMENT	"Image Size"		'(256 1 1024 1 10 0 1)
	SF-COLOR	"Background Color"	'(0 0 0)
	SF-GRADIENT	"Gradient"		"Blue_Green"
	SF-TOGGLE	"Use Gradient?"		TRUE
	SF-ADJUSTMENT	"Iteration"		'(2000 1 50000 10 100 0 0)
	SF-ADJUSTMENT	"Scale"			'(8 0.1 8 0.1 1 1 0)
	SF-ADJUSTMENT	"Initial x0"		'(0.5 0 8 0.1 0.5 2 1)
	SF-ADJUSTMENT	"Initial y0"		'(0.0 0 8 0.1 0.5 2 1)
	SF-ADJUSTMENT	"Parameter a"		'(0.5 0 8 0.1 0.5 2 0)
)
