; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Copy multi layer image script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/09/29
;     - Initial relase
;     - Added Copy Layers option
; version 0.2  by Iccii 2001/09/30
;     - Added Copy Channels option
; version 0.3  by Iccii 2001/09/30
;     - Added Copy Paths option
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;

;           <dlƂ̃oOH AdlłI>
; 
; - CfbNX摜O[XP[摜 RGB 摜ɂȂႤ
; - wiC[͌̓At@`l̂郌C[ɂȂႤ
; - C[Rs[Ȃ͐V摜ɃC[͖


	;; ̉摜̑SẴC[̉摜ɂ܂Ƃ߂XNvg
(define (script-fu-copy-multi-layer
			img1            ;; Ώۉ摜
			drawable        ;; ΏۃhAu (unused)
			img2		;; Ώۉ摜2
			copy-layer      ;; C[Rs[邩?
			copy-channel    ;; `lRs[邩?
			copy-path       ;; pXRs[邩?
	)


;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;  C[̃Rs[
;;;;;;;;;;;;;;;;;;;;


	;; local function to copy all layers in old image into new image

  (define (copy-all-layers-into-image image new-image number)
    (set! count 0)

	;; count++ Ȃ烌C[̖JԂ
    (while (< count number)

	;;  count Ԗڂ̃C[o
      (let* ((layer (aref (cadr (gimp-image-get-layers image)) (- number count 1)))
             (linked  (car (gimp-layer-get-linked  layer)))
             (name    (car (gimp-layer-get-name    layer)))
             (opacity (car (gimp-layer-get-opacity layer)))
             (mode    (car (gimp-layer-get-mode    layer)))
             (mask    (car (gimp-layer-mask        layer)))
             (visible (car (gimp-layer-get-visible layer)))
             (p-trans (car (gimp-layer-get-preserve-trans layer)))
             (tmp-width  (car (gimp-drawable-width  layer)))
             (tmp-height (car (gimp-drawable-height layer)))
             (tmp-layer (car (gimp-layer-new new-image tmp-width tmp-height
                                             RGBA-IMAGE name opacity mode))))

	;; oC[摜ɒǉ
        (gimp-image-add-layer new-image tmp-layer -1)
        (gimp-edit-copy layer)
        (gimp-floating-sel-anchor (car (gimp-edit-paste tmp-layer FALSE)))

	;; C[}XN݂ꍇ̓}XNꏏɒǉ
        (if (< 0 mask)
            (let* ((tmp-mask (car (gimp-layer-create-mask tmp-layer WHITE-MASK))))
              (gimp-image-add-layer-mask new-image tmp-layer tmp-mask)
              (gimp-edit-copy mask)
              (gimp-floating-sel-anchor (car (gimp-edit-paste tmp-mask FALSE)))))

	;; C[̏Ԃf
        (gimp-layer-set-preserve-trans tmp-layer p-trans)
        (gimp-layer-set-visible tmp-layer visible)
        (gimp-layer-set-linked  tmp-layer linked)

      ) ; end of let*
      (set! count (+ count 1))
    ) ; end of while
  ) ; end of define (local function)


;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;  `l̃Rs[
;;;;;;;;;;;;;;;;;;;;


	;; local function to copy all channels in old image into new image

  (define (copy-all-channels-into-image image new-image number)
    (set! count 0)

	;; count++ Ȃ`l̖JԂ
    (while (< count number)

	;;  count Ԗڂ̃`lo
      (let* ((channel (aref (cadr (gimp-image-get-channels image)) (- number count 1)))
             (name    (car (gimp-channel-get-name    channel)))
             (color   (car (gimp-channel-get-color   channel)))
             (opacity (car (gimp-channel-get-opacity channel)))
             (masked  (car (gimp-channel-get-show-masked channel)))
             (tmp-width  (car (gimp-drawable-width  channel)))
             (tmp-height (car (gimp-drawable-height channel)))
             (tmp-channel (car (gimp-channel-new new-image tmp-width tmp-height
                                                 name opacity color))))

	;; o`l摜ɒǉ
        (gimp-image-add-channel new-image tmp-channel -1)
        (gimp-edit-copy channel)
        (gimp-floating-sel-anchor (car (gimp-edit-paste tmp-channel FALSE)))
        (gimp-channel-set-show-masked tmp-channel masked)
	; why gimp-channel-new sets incorrect opacity?
        (gimp-channel-set-opacity     tmp-channel opacity)

      ) ; end of let*
      (set! count (+ count 1))
    ) ; end of while
  ) ; end of define (local function)


;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;  pX̃Rs[
;;;;;;;;;;;;;;;;;;;;


	;; local function to copy all paths in old image into new image

  (define (copy-all-paths-into-image image new-image number)
    (set! count 0)
    (define (list-ref l n) (nth n l))

	;; count++ ȂpX^C̖JԂ
    (while (< count number)

	;;  count Ԗڂ̃pXo
      (let* ((pathname (list-ref (cadr (gimp-path-list image)) (- number count 1)))
             (path-data (gimp-path-get-points image pathname))
             (locked    (car (gimp-path-get-locked image pathname))))

	;; opX摜ɒǉ
        (gimp-path-set-points new-image pathname
                              (list-ref path-data 0)
                              (list-ref path-data 2)
                              (list-ref path-data 3))
        (gimp-path-set-locked new-image pathname locked)

      ) ; end of let*
      (set! count (+ count 1))
    ) ; end of while
  ) ; end of define (local function)


;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;  C
;;;;;;;;;;;;;;;;;;;;


	;; Rs[V摜̍쐬
  (let* (
         (width (car (gimp-image-width img1)))
         (height (car (gimp-image-height img1)))
         (new-img (car (gimp-image-new width height RGB))) 
        ) ; end variable definition

	;; {

    (gimp-image-undo-disable new-img)

    (if (eqv? copy-path TRUE)
        (let* ((number1 (car (gimp-path-list img1)))
               (number2 (car (gimp-path-list img2))))
          (copy-all-paths-into-image img1 new-img number1)
          (copy-all-paths-into-image img2 new-img number2)
        ) ; end of let*
    )

    (if (eqv? copy-channel TRUE)
        (let* ((number1 (car (gimp-image-get-channels img1)))
               (number2 (car (gimp-image-get-channels img2))))
          (copy-all-channels-into-image img1 new-img number1)
          (copy-all-channels-into-image img2 new-img number2)
        ) ; end of let*
    )

    (if (eqv? copy-layer TRUE)
        (let* ((number1 (car (gimp-image-get-layers img1)))
               (number2 (car (gimp-image-get-layers img2))))
          (copy-all-layers-into-image img1 new-img number1)
          (copy-all-layers-into-image img2 new-img number2)
        ) ; end of let*
    )


	;; ㏈
    (gimp-image-undo-enable new-img)
    (if (or (eqv? copy-layer TRUE) (eqv? copy-channel TRUE) (eqv? copy-path TRUE))
        (gimp-display-new new-img)
        (gimp-image-delete new-img))
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-copy-multi-layer"
  "<Image>/Script-Fu/Utils/Copy Multi Layer..."
  "Copy multi layers/channels/paths image into new image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Sep"
  "RGB* GRAY* INDEXED*"
  SF-IMAGE      "Image"            0
  SF-DRAWABLE   "Drawable"         0
  SF-IMAGE      "Image"            0
  SF-TOGGLE     "Copy Layers"      TRUE
  SF-TOGGLE     "Copy Channels"    FALSE
  SF-TOGGLE     "Copy Paths"       FALSE
)
