; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Cross light script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/07/22
;     - Initial relase
; version 0.2  by Iccii 2001/08/09
;     - Add the Start Angle and the Number of Lighting options
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; NXCgXNvg
(define (script-fu-cross-light
			img		;; Ώۉ摜
			drawable	;; ΏۃhAu
			length		;; ̒
			angle		;; ̊px
			number		;; ̊gU
			threshold	;; 臒l
	)
  (let* (
	 (modulo fmod)			;; in R4RS way
	 (count 1)
	 (tmp-layer (car (gimp-layer-copy drawable TRUE)))
	 (target-layer (car (gimp-layer-copy drawable TRUE)))
	 (layer-mask (car (gimp-layer-create-mask target-layer WHITE-MASK)))
        )

    (gimp-undo-push-group-start img)
    (gimp-desaturate tmp-layer)
    (gimp-threshold tmp-layer threshold 255)
    (gimp-edit-copy tmp-layer)

    (gimp-image-add-layer img target-layer -1)
    (gimp-image-add-layer-mask img target-layer layer-mask)
    (gimp-floating-sel-anchor (car (gimp-edit-paste layer-mask 0)))
    (gimp-image-remove-layer-mask img target-layer APPLY)

    (gimp-image-remove-layer img target-layer)
    (gimp-image-add-layer img tmp-layer -1)
    (gimp-drawable-fill tmp-layer TRANS-IMAGE-FILL)

    (while (<= count number)
      (let* (
             (layer-copy (car (gimp-layer-copy target-layer TRUE)))
             (degree (modulo (+ (* count (/ 360 number)) angle) 360))
            )
        (gimp-image-add-layer img layer-copy -1)
        (plug-in-mblur 1 img layer-copy 0 length degree)
        (set! marged-layer (car (gimp-image-merge-down img layer-copy
                                                       EXPAND-AS-NECESSARY)))
        (set! count (+ count 1))
      ) ; end of let*
    ) ; end of while
    (gimp-layer-set-opacity marged-layer 80)
    (gimp-layer-set-mode marged-layer SCREEN-MODE)

	;; ㏈
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-cross-light"
  "<Image>/Script-Fu/Alchemy/Cross Light..."
  "Cross light effect"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Aug"
  "RGB*"
  SF-IMAGE      "Image"			0
  SF-DRAWABLE   "Drawable"		0
  SF-ADJUSTMENT _"Light Length"		'(40 1 255 1 10 0 0)
  SF-ADJUSTMENT _"Start Angle"		'(30 0 360 1 10 0 0)
  SF-ADJUSTMENT "Number of Light"	'(4 1 16 1 2 0 1)
  SF-ADJUSTMENT _"Threshold (Bigger 1<-->255 Smaller)"  '(223 1 255 1 10 0 0)
)
