; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Emboss image script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/10/02 <iccii@hotmail.com>
;     - Initial relase
; version 0.1a by Iccii 2001/10/02 <iccii@hotmail.com>
;     - Added Contrast option
; version 0.1b by Iccii 2001/10/04 <iccii@hotmail.com>
;     - Added Desaturate option
;     - Small fixes in selection area
;
; --------------------------------------------------------------------
;     Reference Book
; http://bookweb.kinokuniya.co.jp/cgi-bin/gwfind.cgi?W-NIPS=9971628929
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; G{XXNvg
(define (script-fu-emboss-image
			img		;; Ώۉ摜
			drawable	;; ΏۃhAu (C[)
			depth		;; G{X̐[
			contrast	;; RgXg
			angle		;; G{X̊px
			desaturate?	;; EF邩ǂ
	)

  (gimp-undo-push-group-start img)

  (let* (
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
	 (old-selection (car (gimp-selection-save img)))
	 (image-type (if (eqv? (car (gimp-drawable-is-gray drawable)) TRUE)
                         GRAYA-IMAGE
                         RGBA-IMAGE))
	 (layer-color1 (car (gimp-layer-new img width height image-type "Color Upper"  50 NORMAL-MODE)))
	 (layer-color2 (car (gimp-layer-new img width height image-type "Color Under" 100 NORMAL-MODE)))
	 (selection-flag FALSE)
        ) ; end variable definition

	;; {
    (if (eqv? (car (gimp-selection-is-empty img)) TRUE)
        (begin
          (gimp-drawable-fill old-selection WHITE-IMAGE-FILL)
          (set! selection-flag TRUE)))
    (gimp-selection-none img)
    (gimp-drawable-fill layer-color2 TRANS-IMAGE-FILL)
    (gimp-drawable-fill layer-color1 TRANS-IMAGE-FILL)
    (gimp-image-add-layer img layer-color2 -1)
    (gimp-image-add-layer img layer-color1 -1)
    (gimp-edit-copy drawable)
    (gimp-floating-sel-anchor (car (gimp-edit-paste layer-color2 0)))
    (gimp-floating-sel-anchor (car (gimp-edit-paste layer-color1 0)))
    (gimp-invert layer-color1)
    (plug-in-mblur 1 img layer-color2 0 depth angle)


	;; C[n
    (set! final-layer (car (gimp-image-merge-down img layer-color1 EXPAND-AS-NECESSARY)))
    (gimp-selection-load old-selection)
    (gimp-edit-copy final-layer)
    (gimp-image-remove-layer img final-layer)
    (gimp-floating-sel-anchor (car (gimp-edit-paste drawable 0)))
    (gimp-image-remove-channel img old-selection)
    (gimp-selection-load old-selection)
    (gimp-brightness-contrast drawable 0 contrast)	; <- Ï悪ԂœƃoỐ͉H
    (if (eqv? desaturate? TRUE)
        (gimp-desaturate drawable))
    (if (eqv? selection-flag TRUE)
        (gimp-selection-none img))


	;; ㏈
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-emboss-image"
  "<Image>/Script-Fu/Photoshop/Emboss..."
  "Creates emboss image, which simulates Photoshop's Emboss filter"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  "RGB* GRAY*"
  SF-IMAGE      "Image"	            0
  SF-DRAWABLE   "Drawable"          0
  SF-ADJUSTMENT "Depth"             '(4 1 16 1 10 0 1)
  SF-ADJUSTMENT "Contrast"          '(64 0 127 1 10 0 0)
  SF-ADJUSTMENT "Angle"             '(135 0 360 1 10 0 0)
  SF-TOGGLE     "Totaly Desaturate" FALSE
)
