; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Ghost logo script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/10/27
;     - Initial relase (Beta version)
;
; --------------------------------------------------------------------
;     Reference Web site
; http://www.sx.sakura.ne.jp/~koki/ex1-10/example8.html
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;



	;; S[XgS

(define (apply-ghost-logo-effect
			img
			logo-layer
			color
			angle)

  (gimp-selection-none img)
  (set! tmp-layer (car (gimp-layer-copy logo-layer TRUE)))
  (gimp-image-add-layer img tmp-layer -1)
  (gimp-image-lower-layer img tmp-layer)
  (gimp-layer-set-preserve-trans logo-layer TRUE)
  (gimp-palette-set-background '(0 0 0))
  (gimp-edit-fill logo-layer BG-IMAGE-FILL)
  (gimp-drawable-fill tmp-layer WHITE-IMAGE-FILL)
  (gimp-layer-set-preserve-trans logo-layer FALSE)
  (set! layer (car (gimp-image-merge-down img logo-layer EXPAND-AS-NECESSARY)))
  (plug-in-blur-randomize 1 img layer 100 15 10 100)

  (let* (
         (img-width (car (gimp-drawable-width layer)))
         (img-height (car (gimp-drawable-height layer)))
         (copy-layer1 (car (gimp-layer-copy layer TRUE)))
         (copy-layer2 (car (gimp-layer-copy layer TRUE)))
         (copy-layer3 (car (gimp-layer-copy layer TRUE)))
         (color-layer (car (gimp-layer-new img img-width img-height RGBA-IMAGE
                                           "Color Layer" 100 ADDITION-MODE)))
         (x-offset (* (cos (/ (* 2 *pi* angle) 360)) 5))
         (y-offset (* (sin (/ (* 2 *pi* angle) 360)) 5))
        )

    (gimp-image-resize img img-width img-height 0 0)
    (gimp-image-add-layer img copy-layer1 -1)
    (gimp-image-add-layer img copy-layer2 -1)
    (gimp-image-add-layer img copy-layer3 -1)
    (gimp-image-add-layer img color-layer -1)

    (gimp-palette-set-background '(255 255 255))
    (gimp-channel-ops-offset copy-layer3 TRUE OFFSET-BACKGROUND x-offset y-offset)
    (gimp-channel-ops-offset copy-layer1 TRUE OFFSET-BACKGROUND x-offset y-offset)
    (gimp-layer-set-mode copy-layer3 DIFFERENCE-MODE)
    (gimp-layer-set-mode copy-layer1 MULTIPLY-MODE)
    (set! top-layer1 (car (gimp-image-merge-down img copy-layer1 EXPAND-AS-NECESSARY)))
    (set! top-layer2 (car (gimp-image-merge-down img copy-layer3 EXPAND-AS-NECESSARY)))
    (gimp-invert top-layer2)
    (gimp-levels top-layer2 VALUE-LUT 128 255 0.5   0 255)
    (gimp-palette-set-background color)
    (gimp-drawable-fill color-layer BG-IMAGE-FILL)
    (set! top-layer3 (car (gimp-image-merge-down img color-layer EXPAND-AS-NECESSARY)))
    (gimp-layer-set-mode top-layer3 DIFFERENCE-MODE)
    (set! top-layer  (car (gimp-image-merge-down img top-layer3 EXPAND-AS-NECESSARY)))

  ) ; end of let*
) ; end of define


	;; S[XgS쐬

(define (script-fu-ghost-logo
			text
		 	size
			fontname
			text-color
			angle
	)

  (let* (
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
         (img (car (gimp-image-new 256 256 RGB)))
         (padding (max (* size 0.2) 5))
	) ; end variable definition

    (gimp-image-undo-disable img)
    (gimp-palette-set-background '(0 0 0))
    (let ((text-layer (car (gimp-text-fontname img -1 0 0 text padding TRUE
                                               size PIXELS fontname))))
      (gimp-layer-set-name text-layer text text)
      (apply-ghost-logo-effect img text-layer text-color angle))
    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-image-undo-enable img)
    (gimp-display-new img)))


(script-fu-register
  "script-fu-ghost-logo"
  "<Toolbox>/Xtns/Script-Fu/Logos/Ghost Logo..."
  "Create ghost logo image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Oct"
  ""
  SF-STRING     _"Text"		"Ghost..."
  SF-ADJUSTMENT _"Font Size (pixels)"	'(150 2 500 1 1 0 1)

  SF-FONT       _"Font"
; Default setting
;	"-*-tekton-*-r-*-*-24-*-*-*-p-*-*-*"
; For Windows user
	"-*-Times New Roman-bold-r-*-*-24-*-*-*-p-*-iso8859-1"

  SF-COLOR      _"Text Color"	'(127 0 255)
  SF-ADJUSTMENT "Angle"		'(45 0 360 1 15 0 0)
)
