; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Draw dotted imgae script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/07/17
;     - Initial relase
; version 0.1a by Iccii 2001/07/18
;     - Add BG color/layer-opacity option
; version 0.1b by Iccii 2001/07/24
;     - Remove BG color/layer-opacity option
;     - Optimize (speed up) ...thanks to Sakai
; version 0.1c by Iccii 2001/08/21
;     - Added this line: (define (list-ref l n) (nth n l))
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; _`XNvg
(define (script-fu-paint-dot-image
			img		;; Ώۉ摜
			layer		;; ΏۃC[
			tool-type	;; `c[̎
			iteration	;; `̌JԂ
			brush		;; `ɎgpuV̎
			drawing-type	;; _`̔zu̎
			spacing		;; _`̔zůԊu䗦
	)

  (define (list-ref l n) (nth n l))

	;; min  max ܂ł̃_ȐԂ
  (define (get-random-number min max)
	(+ min (rand (- max min))))

  (let* (
	 (strokes (cons-array 2 'double))
	 (old-brush (car (gimp-brushes-get-brush)))
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (width (car (gimp-drawable-width layer)))
	 (height (car (gimp-drawable-height layer)))
	 (dot-layer (car (gimp-layer-new img width height RGBA_IMAGE "Dot image" 100 NORMAL)))
	 (x-coordinate '())
	 (y-coordinate '())
	 (count 0)
	)

	;; O
    (gimp-undo-push-group-start img)
    (gimp-edit-clear dot-layer)
    (gimp-brushes-set-brush (car brush))
    (gimp-image-add-layer img dot-layer -1)
    (define dot-proc
      (cond
        ((eqv? tool-type 0) gimp-pencil)
        ((eqv? tool-type 1) gimp-airbrush-default)
        ((eqv? tool-type 2) gimp-paintbrush-default)))
    (cond
      ((eqv? drawing-type 0)
        (while (> iteration count)
          (set! x-coordinate (cons (get-random-number 0 (- width 1)) x-coordinate))
          (set! y-coordinate (cons (get-random-number 0 (- height 1)) y-coordinate))
          (set! count (+ count 1))
        ) ; end of while
      )
      ((eqv? drawing-type 1)
        (let* ((brush-width (cadr (gimp-brushes-get-brush)))
               (brush-height (caadr (gimp-brushes-get-brush)))
               (drawing-width-step (* brush-width spacing))
               (drawing-height-step (* brush-height spacing)) )
	; write me!
        )
      )
    ) ; end of cond
    (set! count 0)

	;; {
    (while (> (length x-coordinate) count)
      (gimp-color-picker img layer (list-ref x-coordinate count)
                                   (list-ref y-coordinate count) FALSE FALSE 0 TRUE)
      (aset strokes 0 (list-ref x-coordinate count))
      (aset strokes 1 (list-ref y-coordinate count))
      (dot-proc dot-layer 2 strokes)
      (set! count (+ count 1))
    ) ; end of while

	;; ㏈
    (gimp-brushes-set-brush old-brush)
    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-paint-dot-image"
  "<Image>/Script-Fu/Alchemy/Paint Dot Image..."
  "Paint dot image"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Jul"
  "RGB* GRAY*"
  SF-IMAGE      "Image"		0
  SF-DRAWABLE   "Drawable"	0
  SF-OPTION     "Paint Tool"    '("Pencil" "Airbrush" "Paintbrush")
  SF-ADJUSTMENT "Iteration"     '(1000 1 10000 10 100 0 0)
  SF-BRUSH      _"Use Brush"    '("Circle Fuzzy (19)" 1.0 20 0)
  SF-OPTION     "Drawing Type"  '("Random" "Linear")
  SF-ADJUSTMENT "Spacing"       '(1 0.1 10 0.2 1 1 0)
)
