; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Raindrop effect script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/01/30
;     - Initial relase
;       This is "FIXME" version, which is spaghetti program code
; version 0.2  by Iccii 2001/02/09
;     - Add to offset in highlight option
; version 0.2a by Iccii 2001/02/23
;     - Sorry, I had some mistakes, now fixed
; version 0.2b by Iccii 2001/02/24
;     - Highlight offset is set by persent instead of pixel
; version 0.3  by Iccii 2001/03/27
;     - Add the reflect-width setting
;     - Use Pattern as background
;     - Clean up code and more proofing
; version 0.3a by Iccii 2001/03/30
;     - Make better (speed up)
; version 0.3b by Iccii 2001/04/02
;     - Make better (cleanup code)
; version 0.3c by Iccii 2001/04/10
;     - Fix the layer mask problem (Thanks, Kajiyama)
; version 0.3d by Iccii 2001/05/25
;     - A bit better
; version 0.3e by Iccii 2001/06/21
;     - Minor fix
; version 0.3f by Iccii 2001/07/01
;     - bug fix (if image size doesn't equal to drawable size in alpha-logo)
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	; (H)̂悤Ȍ
(define (apply-raindrop-logo-effect
		img			; IMAGE
		logo-layer		; DRAWABLE (C[)
		text-color		; ʂ̐F
		light			; ̕ (0-360x)
		blur			; VhDAnCCĝڂa
		hi-width		; nCCg (%)
		hi-offset		; nCCg̃ItZbg (%)
		hi-option		; nCCg쐬@IvV
		sh-offset		; VhD̃ItZbg
		reflect-width		; \ʔ˂̃oh
		antialias)		; A`GCAX̗L/


	; O
    (set! layer-color (car (gimp-layer-copy logo-layer TRUE)))
    (set! mask-color  (car (gimp-layer-create-mask layer-color BLACK-MASK)))
    (set! old-bg (car (gimp-palette-get-background)))
    (gimp-image-add-layer-mask img layer-color mask-color)
    (gimp-palette-set-background '(0 0 0))
    (gimp-layer-set-preserve-trans logo-layer FALSE)
    (gimp-selection-layer-alpha logo-layer)
    (gimp-edit-fill mask-color WHITE-IMAGE-FILL)
    (gimp-selection-grow img reflect-width)
    (gimp-edit-fill logo-layer WHITE-IMAGE-FILL)
    (if (eqv? antialias TRUE)
	(gimp-selection-feather img (/ blur 5)))
    (gimp-selection-invert img)
    (gimp-edit-fill logo-layer BG-IMAGE-FILL)
    (gimp-palette-set-background old-bg)
    (gimp-selection-none img)
    (set! logo-layer-blur (car (gimp-layer-copy logo-layer TRUE)))
    (plug-in-gauss-iir2 1 img logo-layer-blur blur blur)

	; ̖{̕
  (let* ((old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (radians (/ (* 2 *pi* light) 360))
	 (sh-xoffset (* sh-offset (cos radians)))
	 (sh-yoffset (* sh-offset (sin radians)))
	 (layer-value		(car (gimp-layer-copy logo-layer TRUE)))
	 (layer-hilight		(car (gimp-layer-copy logo-layer TRUE)))
	 (layer-hilight-inn	(car (gimp-layer-copy logo-layer-blur TRUE)))
	 (layer-shadow		(car (gimp-layer-copy logo-layer-blur TRUE)))
	 (layer-shadow-inn	(car (gimp-layer-copy logo-layer-blur TRUE)))
	 (mask-hilight		(car (gimp-layer-create-mask layer-hilight WHITE-MASK)))
	 (mask-hilight-inn	(car (gimp-layer-create-mask layer-hilight-inn WHITE-MASK)))
	 (mask-shadow		(car (gimp-layer-create-mask layer-shadow WHITE-MASK)))
	 (mask-shadow-inn	(car (gimp-layer-create-mask layer-shadow-inn WHITE-MASK))))

	; eC[̏
    (gimp-layer-set-name layer-value		"Value layer")
    (gimp-layer-set-name layer-hilight		"Highlight layer")
    (gimp-layer-set-name layer-hilight-inn	"Highlight inner")
    (gimp-layer-set-name layer-shadow		"Drop shadow")
    (gimp-layer-set-name layer-shadow-inn	"Inner shadow")
    (gimp-layer-set-name layer-color		"Color adjust")
    (gimp-image-add-layer img layer-color -1)
    (gimp-image-add-layer img layer-shadow-inn -1)
    (gimp-image-add-layer img layer-shadow -1)
    (gimp-image-add-layer img layer-hilight-inn -1)
    (gimp-image-add-layer img layer-hilight -1)
    (gimp-image-add-layer img layer-value -1)

	; C[}XNǉ
    (gimp-selection-all img)
    (gimp-edit-copy logo-layer)
    (gimp-selection-none img)
    (gimp-image-add-layer-mask img layer-hilight	mask-hilight)
    (gimp-floating-sel-anchor (car (gimp-edit-paste	mask-hilight 0)))
    (gimp-image-add-layer-mask img layer-hilight-inn	mask-hilight-inn)
    (gimp-floating-sel-anchor (car (gimp-edit-paste	mask-hilight-inn 0)))
    (gimp-image-add-layer-mask img layer-shadow		mask-shadow)
    (gimp-floating-sel-anchor (car (gimp-edit-paste	mask-shadow 0)))
    (gimp-image-add-layer-mask img layer-shadow-inn	mask-shadow-inn)
    (gimp-floating-sel-anchor (car (gimp-edit-paste	mask-shadow-inn 0)))

	; F]AFtAC[[h̕ύXA炵s
    (gimp-invert layer-hilight-inn)
    (gimp-invert mask-shadow)
    (gimp-palette-set-foreground text-color)
    (gimp-drawable-fill layer-color FG-IMAGE-FILL)
    (gimp-layer-set-mode layer-value ADDITION-MODE)
    (gimp-layer-set-mode layer-hilight SCREEN-MODE)
    (gimp-layer-set-mode layer-hilight-inn SCREEN-MODE)
    (gimp-layer-set-mode layer-shadow SUBTRACT-MODE)
    (gimp-layer-set-mode layer-shadow-inn MULTIPLY-MODE)
    (gimp-layer-set-mode layer-color NORMAL-MODE)
    (gimp-channel-ops-offset layer-hilight-inn FALSE OFFSET-BACKGROUND (- sh-xoffset) (- sh-yoffset))
    (gimp-channel-ops-offset layer-shadow      FALSE OFFSET-TRANSPARENT sh-xoffset sh-yoffset)
    (gimp-channel-ops-offset layer-shadow-inn  FALSE OFFSET-BACKGROUND sh-xoffset sh-yoffset)

	; nCCgC[̏
    (gimp-selection-load mask-hilight)
    (gimp-selection-sharpen img)
    (set! hilight-width 0)
    (while (eqv? (car (gimp-selection-is-empty img)) FALSE)
	(gimp-selection-shrink img 1)
	(set! hilight-width (+ hilight-width 1)))
    (gimp-selection-none img)
    (set! hi-xoffset (- (/ (* (* hi-offset (cos radians)) hilight-width) 100)))
    (set! hi-yoffset (- (/ (* (* hi-offset (sin radians)) hilight-width) 100)))
    (gimp-channel-ops-offset layer-hilight FALSE OFFSET-BACKGROUND hi-xoffset hi-yoffset)
    (gimp-channel-ops-offset mask-hilight  FALSE OFFSET-BACKGROUND hi-xoffset hi-yoffset)
    (cond
      ((eqv? hi-option 0)	; k߂Ƃ
        (begin
	  (gimp-selection-load mask-hilight)
	  (gimp-selection-invert img)
	  (gimp-selection-grow img (/ (* hilight-width (- 100 hi-width)) 100))
	  (gimp-palette-set-foreground '(0 0 0))
	  (gimp-edit-fill layer-hilight FG-IMAGE-FILL)
	  (gimp-selection-none img)
	  (plug-in-gauss-iir2 1 img layer-hilight (* 0.8 blur) (* 0.8 blur))
	  (gimp-image-remove-layer-mask img layer-hilight APPLY)))
      ((eqv? hi-option 1)	; ItZbĝƂ...ȂǂKv
        (begin
	  (gimp-channel-ops-offset layer-hilight FALSE OFFSET-BACKGROUND
		  (* (/ (* hilight-width (- 100 hi-width)) 100) (- (cos radians)))
		  (* (/ (* hilight-width (- 100 hi-width)) 100) (- (sin radians))))
	  (gimp-channel-ops-offset mask-hilight FALSE OFFSET-BACKGROUND
		  (* (/ (* hilight-width (- 100 hi-width)) 100) (cos radians))
		  (* (/ (* hilight-width (- 100 hi-width)) 100) (sin radians)))
	  (gimp-image-remove-layer-mask img layer-hilight APPLY)
	  (plug-in-gauss-iir2 1 img layer-hilight (* 0.8 blur) (* 0.8 blur)))))
      (set! mask-hilight2 (car (gimp-layer-create-mask logo-layer WHITE-MASK)))
      (gimp-image-add-layer-mask img layer-hilight	mask-hilight2)
      (gimp-floating-sel-anchor (car (gimp-edit-paste	mask-hilight2 FALSE)))

	; Ō̒
    (gimp-selection-none img)
    (gimp-layer-set-opacity layer-value 15)
    (gimp-layer-set-opacity layer-hilight 90)
    (gimp-layer-set-opacity layer-hilight-inn 90)
    (gimp-layer-set-opacity layer-shadow 80)
    (gimp-layer-set-opacity layer-shadow-inn 80)

	; I
    (gimp-image-remove-layer img logo-layer)
    (gimp-image-set-active-layer img layer-value)
    (gimp-palette-set-background old-bg)
    (gimp-palette-set-foreground old-fg)
))


	; xS
(define (script-fu-raindrop-logo-alpha
		img
		text-layer
		text-color
		light
		blur
		hi-width
		hi-offset
		hi-option
		sh-offset
		reflect-width
		antialias)
  (let* ((width  (car (gimp-drawable-width  text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
	 (bg-layer (car (gimp-layer-new img width height RGBA_IMAGE "BG layer" 100 NORMAL))))
    (gimp-undo-push-group-start img)
    (gimp-image-resize img width height 0 0)
    (if (< 0 (car (gimp-layer-mask text-layer)))
      (begin
	(gimp-image-remove-layer-mask img text-layer APPLY)
	(gimp-displays-flush)		; why I need this call?
	))
    (apply-raindrop-logo-effect
	img text-layer text-color light blur
	hi-width hi-offset hi-option sh-offset reflect-width antialias)
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)))

(script-fu-register
	"script-fu-raindrop-logo-alpha"
	_"<Image>/Script-Fu/Alpha to Logo/Rain drop..."
	"Creates a logo like a raindrop"
	"Iccii <iccii@hotmail.com>"
	"Iccii"
	"Mar, 2001"
	"RGBA"
        SF-IMAGE	"Image"			0
	SF-DRAWABLE	"Drawable"		0
	SF-COLOR	_"Base Color"		'(0 63 255)
	SF-ADJUSTMENT	_"Lighting (degrees)"	'(45 0 360 1 10 0 0)
	SF-ADJUSTMENT	_"Blur Radius"		'(10 1 63 1 5 0 0)
 	SF-ADJUSTMENT	_"Highlight Width (%)"	'(30 0 100 1 5 0 0)
	SF-ADJUSTMENT	_"Highlight Offset (%)"	'(40 0 100 1 5 0 0)
	SF-OPTION	_"Highlight Option"	'(_"Shrink" _"Offset")
	SF-ADJUSTMENT	_"Shadow Offset"	'(5 0 50 1 5 0 1)
	SF-ADJUSTMENT	_"Reflect Width"	'(0 0 50 1 5 0 1)
	SF-TOGGLE	_"Antialias"		FALSE)


	; S쐬
(define (script-fu-raindrop-logo
		text
		font-size
		fontname
		text-color
		pattern
		light
		blur
		hi-width
		hi-offset
		hi-option
		sh-offset
		reflect-width
		antialias)

  (let* ((img (car (gimp-image-new 256 256 RGB)))
	 (text-layer (car (gimp-text-fontname img -1 0 0
				text (+ 20 reflect-width) TRUE font-size PIXELS fontname)))
	 (width  (car (gimp-drawable-width  text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
	 (bg-layer (car (gimp-layer-new img width height RGBA-IMAGE "Background" 100 NORMAL)))
	 (old-pattern (car (gimp-patterns-get-pattern))))
    (gimp-image-undo-disable img)
    (gimp-image-resize img width height 0 0)
    (gimp-image-add-layer img bg-layer -1)
    (gimp-patterns-set-pattern pattern)
    (gimp-selection-all img)
    (gimp-bucket-fill bg-layer 2 0 100 255 FALSE 1 1)
    (gimp-selection-none img)
    (apply-raindrop-logo-effect
	img text-layer text-color light blur
	hi-width hi-offset hi-option sh-offset reflect-width antialias)
    (gimp-patterns-set-pattern old-pattern)
    (gimp-image-undo-enable img)
    (gimp-display-new img)
    (gimp-displays-flush)))

(script-fu-register
	"script-fu-raindrop-logo"
	_"<Toolbox>/Xtns/Script-Fu/Logos/Rain drop..."
	"Create a raindrop like logo"
	"Iccii <iccii@hotmail.com>"
	"Iccii"
	"Jun, 2001"
	""
	SF-STRING	_"Text"			"Rain Drop"
	SF-ADJUSTMENT	_"Font Size (pixels)"	'(150 2 1000 1 10 0 1)
	SF-FONT		_"Font"

	; Default setting
			"-*-slogan-*-r-*-*-24-*-*-*-p-*-*-*"
	; For Windows user
	;		"-*-Times New Roman-bold-r-*-*-24-*-*-*-p-*-iso8859-1"

	SF-COLOR	_"Text Color"		'(0 127 255)
	SF-PATTERN	_"Pattern"              "Pine?"
	SF-ADJUSTMENT	_"Lighting (degrees)"	'(45 0 360 1 10 0 0)
	SF-ADJUSTMENT	_"Blur Radius"		'(10 1 50 1 5 0 0)
	SF-ADJUSTMENT	_"Highlight Width (%)"	'(30 0 100 1 5 0 0)
	SF-ADJUSTMENT	_"Highlight Offset (%)"	'(40 0 100 1 5 0 0)
	SF-OPTION	_"Highlight Option"	'(_"Shrink" _"Offset")
	SF-ADJUSTMENT	_"Shadow Offset"	'(5 0 50 1 5 0 1)
	SF-ADJUSTMENT	_"Reflect Width"	'(0 0 50 1 5 0 1)
	SF-TOGGLE	_"Antialias"		FALSE)
