; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Re-compose with dissolve script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/07/24
;     - Initial relase
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; e`lɉ摜𕪉čč
(define (script-fu-dissolve-recompose
			img		;; Ώۉ摜
			layer		;; ΏۃC[
			compose-type	;;  () [h
	)

	;; ZKpO[XP[摜Ԃ
  (define (get-dissolved-image img)
    (let* (
	   (drawable (car (gimp-image-active-drawable img)))
	   (width (car (gimp-drawable-width drawable)))
	   (height (car (gimp-drawable-height drawable)))
	   (layer1 (car (gimp-layer-new img width height GRAYA_IMAGE "Blask" 100 NORMAL)))
	   (layer2 (car (gimp-layer-new img width height GRAYA_IMAGE "White" 100 DISSOLVE)))
	   (layer2-mask (car (gimp-layer-create-mask layer2 WHITE-MASK)))
	  )
      (gimp-image-add-layer img layer1 -1)
      (gimp-image-add-layer img layer2 -1)
      (gimp-image-add-layer-mask img layer2 layer2-mask)
      (gimp-drawable-fill layer1 WHITE-IMAGE-FILL)
      (gimp-drawable-fill layer2 WHITE-IMAGE-FILL)
      (gimp-invert layer1)
      (gimp-edit-copy drawable)
      (gimp-floating-sel-anchor (car (gimp-edit-paste layer2-mask 0)))
      (gimp-image-remove-layer-mask img layer2 APPLY)
      (set! final-layer (car (gimp-image-flatten img)))
      (list img final-layer)))

  (let* (
	 (decompose-type (cond ((= compose-type 0) "RGB")
                               ((= compose-type 1) "HSV")
                               ((= compose-type 2) "CMY")
                               ((= compose-type 3) "CMYK")))
	 (decompose-result (plug-in-decompose 1 img layer decompose-type))
	 (image1 (car (get-dissolved-image (car decompose-result))))
	 (image2 (car (get-dissolved-image (cadr decompose-result))))
	 (image3 (car (get-dissolved-image (caddr decompose-result))))
	 (image4 (if (= compose-type 3)
	             (car (get-dissolved-image (cadr (cddr decompose-result))))
	             FALSE ))
	 (result-img (car (plug-in-compose 1 image1 layer
	                                   image2 image3 image4 decompose-type)))
        )

	;; ㏈
    (gimp-display-new result-img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-dissolve-recompose"
  "<Image>/Script-Fu/Utils/Recompose with Dissolve..."
  "Recompose with dissolve"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Jul"
  "RGB*"
  SF-IMAGE      "Image"		0
  SF-DRAWABLE   "Drawable"	0
  SF-OPTION     "Compose Type"  '("RGB" "HSV" "CMY" "CMYK")
)
