; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Select drawing area script  for GIMP 1.2
; Copyright (C) 2001 Iccii <iccii@hotmail.com>
; 
; This script was born of Gotou's idea.
; 
; --------------------------------------------------------------------
; version 0.1  by Iccii 2001/07/16
;     - Initial relase
; version 0.1a by Iccii 2001/07/18
;     - Minor fix (if selection exists...)
; version 0.2  by Iccii 2001/07/24
;     - Added "Keep Channel" and "Invert" toggle
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.  
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;


	;; `敔ÏɂXNvg
(define (script-fu-select-draw-area
			img		;; Ώۉ摜
			drawable	;; ΏۃhAu
			invert?		;; ]Ïɂ邩ǂ
			keep-channel?	;; `lۑ邩ǂ
	)
  (let* (
	 (old-fg (car (gimp-palette-get-foreground)))
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
	 (channel (car (gimp-channel-new img width height "Base Opacity" 100 '(255 0 0))))
	 (active-drawable (car (gimp-image-active-drawable img)))
        ) ; end variable definition

    (gimp-undo-push-group-start img)
    (gimp-palette-set-foreground '(0 0 0))
    (if (eqv? invert? FALSE)
        (gimp-drawable-fill channel WHITE-IMAGE-FILL)
        (gimp-drawable-fill channel FG-IMAGE-FILL))
    (gimp-channel-set-visible channel FALSE)
    (gimp-image-add-channel img channel -1)
    (gimp-edit-copy drawable)
    (gimp-floating-sel-anchor (car (gimp-edit-paste channel 0)))
    (if (eqv? invert? FALSE)
        (gimp-invert channel))
    (gimp-selection-load channel)


	;; ㏈
    (if (eqv? keep-channel? FALSE)
        (gimp-image-remove-channel img channel))
    (if (eqv? (car (gimp-drawable-is-layer active-drawable)) TRUE)
        (gimp-image-set-active-layer img active-drawable)
        (gimp-image-set-active-channel img active-drawable))
    (gimp-palette-set-foreground old-fg)
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
  )
)

(script-fu-register
  "script-fu-select-draw-area"
  "<Image>/Script-Fu/Selection/Drawing Area..."
  "Select drawing area (depending on image's shade)"
  "Iccii <iccii@hotmail.com>"
  "Iccii"
  "2001, Jul"
  "RGB* GRAY*"
  SF-IMAGE      "Image"		0
  SF-DRAWABLE   "Drawable"	0
  SF-TOGGLE     "Invert"        FALSE
  SF-TOGGLE     "Keep Channel"  TRUE
)
