; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; AquaPro script  for GIMP 1.2
;
; The original Perl-Fu script was written by Denis Bodor <b.bodor@calixo.net>
;   - http://www.linuxmag-france.org/redactor_zone/simple.html
;
; Translated into Script-Fu by Iccii <iccii@hotmail.com>
; 
; --------------------------------------------------------------------
; version 1.0  by Iccii 2001/09/14
;     - Initial relase
;
; --------------------------------------------------------------------
; 
; #################################################################################
; #
; # simplebou.pl
; # A Perl-Fu that create a simple push button
; #
; # Copyright (C) 2001 Denis Bodor <b.bodor@calixo.net>
; #
; # This program is free software; you can redistribute it and/or 
; # modify it under the terms of the GNU General Public License   
; # as published by the Free Software Foundation; either version 2
; # of the License, or (at your option) any later version.
; #
; # This program is distributed in the hope that it will be useful,
; # but WITHOUT ANY WARRANTY; without even the implied warranty of
; # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; # GNU General Public License for more details.
; #
; # You should have received a copy of the GNU General Public License
; # along with this program; if not, write to the Free Software
; # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
; #
; #################################################################################


(define (script-fu-simple-button
			radius
			bbasecol
			ebasecol
			bbordcol
			ebordcol
			bgcol)


;  (define (selz img)
;    (gimp-ellipse-select img 40 40 176 176 REPLACE TRUE 0 0)
;  )


  (let* (
	 (WHITE '(255 255 255))
	 (BLACK '(  0   0   0))

	 (s_base (* radius 2))
	 (s_ibord (+ s_base (/ (* 2 radius) 12)))	; (radius*2)/50
	 (s_bord (+ s_ibord (/ (* 2 radius) 3)))	; (radius*2)/10
	 (size (+ s_bord (/ (* 2 radius) 3)))

	 (div (/ radius 64))

	 (image (car (gimp-image-new size size RGB)))
	;; Set new selections for the fore and background-color.
	 (old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))

	 (fond (car (gimp-layer-new image size size RGB_IMAGE
	                                  "Background" 100 NORMAL-MODE)))
	 (bord (car (gimp-layer-new image size size RGBA_IMAGE
	                                  "Border" 100 NORMAL-MODE)))
	 (ibord (car (gimp-layer-new image size size RGBA_IMAGE
	                                   "Inside border" 100 NORMAL-MODE)))
	 (base (car (gimp-layer-new image size size RGBA_IMAGE
	                                  "Base" 100 NORMAL-MODE)))
	 (ombre (car (gimp-layer-new image size size RGBA_IMAGE
	                                   "Shadow" 100 OVERLAY-MODE)))
	 (refl (car (gimp-layer-new image size size RGBA_IMAGE
	                                  "Reflect" 78 NORMAL-MODE)))
	)


    (gimp-image-undo-disable image)

    (gimp-edit-clear fond)
    (gimp-edit-clear bord)
    (gimp-edit-clear ibord)
    (gimp-edit-clear base)
    (gimp-edit-clear ombre)
    (gimp-edit-clear refl)

    (gimp-image-add-layer image refl  0)
    (gimp-image-add-layer image ombre 1)
    (gimp-image-add-layer image base  2)
    (gimp-image-add-layer image ibord 3)
    (gimp-image-add-layer image bord  4)
    (gimp-image-add-layer image fond  5)

	;; fill the background
    (gimp-palette-set-foreground bgcol)
    (gimp-edit-fill fond FG-IMAGE-FILL)

	;; make border
    (gimp-palette-set-foreground bbordcol)
    (gimp-palette-set-background ebordcol)
    (gimp-ellipse-select image (/ radius 3)
                               (/ radius 3) s_bord s_bord REPLACE TRUE 0 0)
    (gimp-blend bord FG-BG-RGB NORMAL-MODE RADIAL 100 0
                     REPEAT-NONE FALSE 0 0 (* radius 1.3) (* radius 1.3) s_bord s_bord)

	;; make inside border
    (gimp-ellipse-select image (/ radius 1.5)
                               (/ radius 1.5) s_ibord s_ibord REPLACE TRUE 0 0)

    (gimp-blend ibord FG-BG-RGB NORMAL-MODE RADIAL 100 0
                      REPEAT-NONE FALSE 0 0 s_bord s_bord (/ radius 3) (/ radius 3))
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image ibord (* 3 div) (* 3 div))

	;;make base
    (gimp-ellipse-select image (+ (/ radius 1.5) (/ radius 12))
                               (+ (/ radius 1.5) (/ radius 12)) s_base s_base 2 1 0 0)
    (gimp-palette-set-foreground bbasecol)
    (gimp-palette-set-background ebasecol)
    (gimp-blend base FG-BG-RGB NORMAL-MODE RADIAL 100 0
                     REPEAT-NONE FALSE 0 0 (* radius 1.3) (* radius 1.3) s_base s_base)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image base (* 1 div) (* 1 div))

	;;make shadow
    (gimp-ellipse-select image (+ (/ radius 1.5) (/ radius 12))
                               (+ (/ radius 1.5) (/ radius 12)) s_base s_base REPLACE TRUE 0 0)
    (gimp-palette-set-foreground BLACK)
    (gimp-edit-fill ombre FG-IMAGE-FILL)
    (gimp-selection-shrink image (* 5 div))
    (gimp-edit-clear ombre)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image ombre (* 22 div) (* 22 div))
    (gimp-ellipse-select image (+ (/ radius 1.5) (/ radius 12))
                               (+ (/ radius 1.5) (/ radius 12)) s_base s_base REPLACE TRUE 0 0)
    (gimp-selection-invert image)
    (gimp-edit-clear ombre)
    (gimp-selection-none image)

	;; make reflect
    (gimp-ellipse-select image (+ (/ radius 1.5) (/ radius 12))
                               (+ (/ radius 1.5) (/ radius 12)) s_base s_base REPLACE TRUE 0 0)
    (gimp-ellipse-select image (/ radius 1.7)
                               (/ radius 1.7) s_base s_base SUB TRUE 0 0)
    (gimp-selection-shrink image (* 2 div))
    (gimp-palette-set-foreground WHITE)
    (gimp-edit-fill refl FG-IMAGE-FILL)
    (gimp-selection-none image)
    (plug-in-gauss-rle2 TRUE image refl (* 18 div) (* 18 div))


    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-image-undo-enable image)
    (gimp-display-new image)
    (gimp-displays-flush)

    image	; Return

  ) ; end of let*
)


(script-fu-register
	"script-fu-simple-button"
	"<Toolbox>/Xtns/Script-Fu/Buttons/Simple One..."
	"Creates a very basic button\n
This script creates a basic button using gradients and blur. Very usefull for Website, i think."
	"Denis Bodor"
	"lefinnois@lefinnois.net"
	"0.0"
	""
	SF-ADJUSTMENT	"Radius"		'(64 1 1024 1 10 0 1)
	SF-COLOR	"Button Color"		'(249 105 105)
	SF-COLOR	"Button Color"		'(168  12  12)
	SF-COLOR	"Border Color"		'(255 255 255)
	SF-COLOR	"Border Color"		'(  0   0   0)
	SF-COLOR	"Background Color"	'(255 255 255)
)
