; The GIMP -- an image manipulation program
; Copyright (C) 1995 Spencer Kimball and Peter Mattis
; 
; Wrap paint effect Script  for GIMP 1.2
;   <Image>/Script-Fu/Alchemy/Wrap Effect...
; 
; --------------------------------------------------------------------
;   - Changelog -
; version 0.1  by Iccii 2001/04/15 <iccii@hotmail.com>
;     - Initial relase
; version 0.2  by Iccii 2001/10/01 <iccii@hotmail.com>
;     - Changed menu path because this script attempts to PS's filter
;     - Added some code (if selection exists...)
;
; --------------------------------------------------------------------
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
(define (script-fu-wrap-effect	inImage
				inDrawable
				inRadius
				inGamma1
				inGamma2
				inSmooth
	)

	(gimp-undo-push-group-start inImage)

	(set! theOld-bg (car (gimp-palette-get-background)))
	(set! theNewlayer (car (gimp-layer-copy inDrawable 1)))
	(set! theOldselection (car (gimp-selection-save inImage)))
	(gimp-layer-set-name theNewlayer "Wrap effect")
	(gimp-layer-set-mode theNewlayer NORMAL-MODE)
	(gimp-image-add-layer inImage theNewlayer -1)

	(gimp-desaturate theNewlayer)
	(plug-in-gauss-iir2 1 inImage theNewlayer inRadius inRadius)
	(plug-in-edge 1 inImage theNewlayer 10.0 1)
	(gimp-invert theNewlayer)

	; theNewlayerVM[

	(if (eqv? inSmooth TRUE)
	    (plug-in-gauss-iir2 0 inImage theNewlayer 5 5))
	(gimp-edit-copy theNewlayer)

	(if (< 0 (car (gimp-layer-mask theNewlayer)))
	    (gimp-image-remove-layer-mask inImage theNewlayer APPLY))
	(set! theLayermask (car (gimp-layer-create-mask theNewlayer BLACK-MASK)))
	(gimp-image-add-layer-mask inImage theNewlayer theLayermask)
	(gimp-floating-sel-anchor (car (gimp-edit-paste theLayermask 0)))

	(gimp-levels theNewlayer 0 0 255 (/ inGamma1 10) 0 255)
	(gimp-levels theNewlayer 0 0 255 (/ inGamma1 10) 0 255)
	(gimp-levels theLayermask 0 0 255 (/ inGamma2 10) 0 255)
	(gimp-levels theLayermask 0 0 255 (/ inGamma2 10) 0 255)

	(gimp-image-remove-layer-mask inImage theNewlayer APPLY)
	(gimp-selection-load theOldselection)
	(gimp-edit-copy theNewlayer)
	(gimp-image-remove-layer inImage theNewlayer)
	(gimp-floating-sel-anchor (car (gimp-edit-paste inDrawable 0)))
	(gimp-selection-load theOldselection)
	(gimp-image-remove-channel inImage theOldselection)

	(gimp-palette-set-background theOld-bg)
	;(gimp-image-set-active-layer inImage inDrawable)
	(gimp-undo-push-group-end inImage)
	(gimp-displays-flush)
)

(script-fu-register
	"script-fu-wrap-effect"
	"<Image>/Script-Fu/Photoshop/Wrap Effect..."
	"Draws with wrap effect, which simulates Photoshop's Wrap filter"
	"Iccii <iccii@hotmail.com>"
	"Iccii"
	"Oct, 2001"
	"RGB*"
	SF-IMAGE	"Image"			0
	SF-DRAWABLE	"Drawable"		0
	SF-ADJUSTMENT	"Randomness"		'(10 0 32 1 10 0 0)
	SF-ADJUSTMENT	"Highlight Balance"	'(3.0 1.0 10 0.5 0.1 1 0)
	SF-ADJUSTMENT	"Edge Amount"		'(3.0 1.0 10 0.5 0.1 1 0)
	SF-TOGGLE	"Smooth"		FALSE
)
